<div
  class="full-height full-width flex-column"
  style="overflow: hidden"
  [attr.data-test-element-id]="'requirement-statistics-panel'"
>
  <div
    #panel
    class="full-height full-width grid-two-columns"
    style="overflow: hidden"
  >
    @if (hasSelection()) {
      <div
        #coverageChart
        [attr.data-test-element-id]="'coverage-requirement'"
        class="chart"
      ></div>
      <div
        #statusChart
        [attr.data-test-element-id]="'status-requirement'"
        class="chart"
      ></div>
      <div
        #criticalityChart
        [attr.data-test-element-id]="'criticality-requirement'"
        class="chart"
      ></div>
      <div
        #descriptionChart
        [attr.data-test-element-id]="'description-requirement'"
        class="chart"
      ></div>
      <div class="flex-column">
        <div class="flex-fixed-size m-l-auto font-18-px label-color">
          <b>{{
            'sqtm-core.requirement-workspace.statistics.coverage-by-crit.title'
              | translate
          }}</b>
          <div
            nz-icon
            nzType="sqtm-core-generic:help"
            nzTheme="outline"
            nz-tooltip
            [nzTooltipTitle]="graphTooltip"
            [nzTooltipTitleContext]="{
              content:
                'sqtm-core.requirement-workspace.statistics.coverage-by-crit.chart-text-description'
            }"
            class="m-l-5"
          ></div>
        </div>
        <div #coverageByCriticalityChartWrapper class="flex-row">
          <div
            #coverageByCriticalityChart
            [attr.data-test-element-id]="'coverage-by-criticality'"
            class="chart"
          ></div>
          <div
            [style.width]="LEGEND_WIDTH + 'px'"
            #coverageByCriticalityChartLegendWrapper
            class="legend_side"
          >
            <div>
              <div class="font-16-px label-color">
                <b>{{
                  'sqtm-core.requirement-workspace.statistics.global-rates'
                    | translate
                }}</b>
              </div>
              <div class="global_rate success_color m-t-10">
                {{ calculateCoverageGlobalCoveredRate() }}%
              </div>
              <div class="global_rate failure_color m-t-10 m-b-50">
                {{ calculateCoverageGlobalUncoveredRate() }}%
              </div>
            </div>
            <div>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.CRITICAL.i18nKey | translate,
                    radius: 7
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.MAJOR.i18nKey | translate,
                    radius: 6
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.MINOR.i18nKey | translate,
                    radius: 5
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.UNDEFINED.i18nKey | translate,
                    radius: 4
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  simpleLegend;
                  context: {
                    label:
                      'sqtm-core.requirement-workspace.statistics.coverage-by-crit.covered'
                      | translate,
                    color: SUCCESS_COLOR
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  simpleLegend;
                  context: {
                    label:
                      'sqtm-core.requirement-workspace.statistics.coverage-by-crit.uncovered'
                      | translate,
                    color: FAILURE_COLOR
                  }
                "
              ></ng-container>
            </div>
          </div>
        </div>
      </div>
      <div class="flex-column">
        <div class="flex-fixed-size m-l-auto font-18-px label-color">
          <b>{{ getValidationStatisticsTitle() }}</b>
          <div
            nz-icon
            nzType="sqtm-core-generic:help"
            nzTheme="outline"
            nz-tooltip
            [nzTooltipTitle]="graphTooltip"
            [nzTooltipTitleContext]="{
              content:
                'sqtm-core.requirement-workspace.statistics.validation-by-crit.chart-text-description'
            }"
            class="m-l-5"
          ></div>
        </div>
        <div #validationByCriticalityChartWrapper class="flex-row">
          <div
            #validationByCriticalityChart
            [attr.data-test-element-id]="'validation-by-criticality'"
            class="chart"
          ></div>
          <div
            [style.width]="LEGEND_WIDTH + 'px'"
            #validationByCriticalityChartLegendWrapper
            class="legend_side"
          >
            <div>
              <div class="font-16-px label-color">
                <b>{{
                  'sqtm-core.requirement-workspace.statistics.global-rates'
                    | translate
                }}</b>
              </div>
              <div class="global_rate success_color m-t-10">
                {{ calculateValidationGlobalConclusiveRate() }}%
              </div>
              <div class="global_rate failure_color m-t-10 m-b-50">
                {{ calculateValidationGlobalInconclusiveRate() }}%
              </div>
            </div>
            <div>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.CRITICAL.i18nKey | translate,
                    radius: 7
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.MAJOR.i18nKey | translate,
                    radius: 6
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.MINOR.i18nKey | translate,
                    radius: 5
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  criticalityLegend;
                  context: {
                    label: RequirementCriticality.UNDEFINED.i18nKey | translate,
                    radius: 4
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  simpleLegend;
                  context: {
                    label:
                      'sqtm-core.requirement-workspace.statistics.validation-by-crit.conclusive'
                      | translate,
                    color: SUCCESS_COLOR
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  simpleLegend;
                  context: {
                    label:
                      'sqtm-core.requirement-workspace.statistics.validation-by-crit.inconclusive'
                      | translate,
                    color: FAILURE_COLOR
                  }
                "
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="
                  simpleLegend;
                  context: {
                    label:
                      'sqtm-core.requirement-workspace.statistics.validation-by-crit.undefined'
                      | translate,
                    color: UNDEFINED_COLOR
                  }
                "
              ></ng-container>
            </div>
          </div>
        </div>
      </div>
      <div></div>
    } @else {
      <div
        [attr.data-test-element-id]="'footer'"
        class="label-color font-16-px txt__semi-bold"
      >
        {{
          'sqtm-core.requirement-workspace.statistics.no-selection' | translate
        }}
      </div>
    }
  </div>
  @if (hasSelection()) {
    <div
      [attr.data-test-element-id]="'footer'"
      class="flex-fixed-size label-color font-16-px txt__semi-bold"
    >
      {{ 'sqtm-core.requirement-workspace.statistics.summary' | translate }}
      <a (click)="searchOnCriteria(createFilterOnCurrentVersion())">{{
        this.statistics.selectedIds.length
      }}</a>
    </div>
  }
</div>

<ng-template #criticalityLegend let-radius="radius" let-label="label">
  <div class="flex-row m-l-10">
    <div style="width: 20px; height: 20px" class="flex-fixed-size">
      <svg
        viewBox="0 0 20 20"
        fill="white"
        stroke="black"
        stroke-width="1"
        xmlns="http://www.w3.org/2000/svg"
      >
        <circle cx="10" cy="10" [attr.r]="radius" />
      </svg>
    </div>
    <span class="m-l-5">{{ label }}</span>
  </div>
</ng-template>

<ng-template #simpleLegend let-label="label" let-color="color">
  <div class="flex-row m-l-10">
    <div style="width: 20px; height: 20px" class="flex-fixed-size">
      <svg
        viewBox="0 0 20 20"
        [attr.fill]="color"
        stroke-width="1"
        xmlns="http://www.w3.org/2000/svg"
      >
        <rect x="4" y="4" width="12" height="12" />
      </svg>
    </div>
    <span class="m-l-5">{{ label }}</span>
  </div>
</ng-template>

<ng-template #graphTooltip let-content="content">
  <span style="width: 600px" [innerHTML]="content | translate"></span>
</ng-template>
